<?php
namespace Controllers;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Teknisa\Libs\Service\CRUD;
use Zeedhi\Framework\HTTP\Request;

class LogController {
    protected $dataSourceManager;
    protected $dataSourceName = 'usr_log_webservice';
    protected $newCodeMasterKey = 'INTEGRA_WEBSERV_CABEC/FILIALXXXX';
    protected $newCodeDrillKey = 'INTEGRA_WEBSERV_DRILL/FILIALXXXX';
    protected $httpRequest;
    
    public function __construct($environment, $dataSourceManager, $newCode, $crudService) {
        $this->dataSourceManager = $dataSourceManager;
        $this->filialLogada = $environment->getCdFilial();
        $this->newCode = $newCode;
        $this->nrorg = $environment->getNrorg();
        $this->crudService = $crudService;
    }
    
    
    
    public function saveMasterLog($objectToSave, $message = null, $autoSaveDrill = true){
        $this->getHttpRequest();
        $method = Request::getMethod();
      #  var_dump($this->httpRequest->server);die;
        $route = $this->httpRequest->get('server');
        $json = json_encode($objectToSave);
        $objectToSave['DSMETODO'] = $method;
        $objectToSave['XMLLOG'] = $json;
        $newCode = $this->newCode->getCodeByTableName('USR_LOG_WEBSERVICE', $this->nrorg);
        $objectToSave['SEQLOG'] = $newCode;
        $objectToSave['OBSLOG'] = $message;
        $objectToSave['__is_new'] = true;
        
        $dataSetToSave = new DataSet("usr_log_webservice", [$objectToSave]);
        $newRequest = new DTO\Request\DataSet($dataSetToSave, '', '', '');
        $dataSetToSave = $this->crudService->getRowsToSave($newRequest, "usr_log_webservice");
        $dataSetToSave = new DataSet("usr_log_webservice", $dataSetToSave);
        $this->dataSourceManager->persist($dataSetToSave);
        
        if($autoSaveDrill){
            $arrayDrillNames = ['ITEN', 'ITENS', 'PRODUTO', 'PRODUTOS', 'PRODUCT', 'PRODUCTS', 'Produtos', 'produtos', 'produto'];
            foreach($arrayDrillNames as $detalhe){
                if(isset($objectToSave[$detalhe])){
                    $this->saveDrillLog($objectToSave[$detalhe], $newCode, $message);
                }
            }
        }
    }
    
    public function saveDrillLog($arrDrill, $seqlog = 1, $message = null){
        if(!is_array($arrDrill))
            $arrDrill = [$arrDrill];
            
        foreach($arrDrill as &$detalhe){
            $json = json_encode($detalhe);
            $detalhe['XMLLOG'] = $json;
            $newCode = $this->newCode->getCodeByTableName('USR_LOG_WEBSERVICE_DRILL', $this->nrorg);
            $detalhe['SEQLOG'] = $seqlog;
            $detalhe['SEQLOGDRILL'] = $newCode;
            $detalhe['OBSLOG'] = $message;
            $detalhe['__is_new'] = true;
        }
        
        $dataSetToSave = new DataSet("usr_log_webservice_drill", $arrDrill);
        $newRequest = new DTO\Request\DataSet($dataSetToSave, '', '', '');
        $dataSetToSave = $this->crudService->getRowsToSave($newRequest, "usr_log_webservice_drill");
        $dataSetToSave = new DataSet("usr_log_webservice_drill", $dataSetToSave);
        $this->dataSourceManager->persist($dataSetToSave);
    }
    
    public function getHttpRequest() {
        if ($this->httpRequest === null) {
            $this->httpRequest = Request::initFromGlobals();
        }
        #var_dump($this->httpRequest->server->get('SERVER_NAME'));die;
        #var_dump(get_class_methods($this->httpRequest));die;
        
        return $this->httpRequest; 
    }
}