/* Tabela DADOSENDPED: Endereo de entrega do pedido */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela DADOSENDPED */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Endereos de entrega do pedido
             utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_PED_DADOSENDPED
AFTER UPDATE OR INSERT OR DELETE
ON DADOSENDPED FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(4000);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_IDTPENDECLIE VARCHAR2(80);
  V_TAM          INTEGER;
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DSREMOTEADDR := ' ';
   V_DSREMOTEHOST := ' ';
   V_DSSERVERRDM  := ' ';
   V_DSSERVMETHOD := ' ';
   V_DSREMOTEOPER := ' ';
   V_DESC         := ' ';
   V_ITPESQ       := ' ';
   V_NMOPERADOR   := ' ';
   V_IDTIPOOPER   := ' ';
   V_IDTPENDECLIE := ' ';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN
      IF :NEW.IDTPENDECLIE = 'P' THEN
         V_IDTPENDECLIE := 'Identificador do tipo de endereo: Principal ';
      ELSE
         IF :NEW.IDTPENDECLIE = 'C' THEN
            V_IDTPENDECLIE := 'Identificador do tipo de endereo: Cobrana ';
         ELSE
            IF :NEW.IDTPENDECLIE = 'E' THEN
               V_IDTPENDECLIE := 'Identificador do tipo de endereo: Exterior ';
            ELSE
               IF :NEW.IDTPENDECLIE = 'X' THEN
                  V_IDTPENDECLIE := 'Identificador do tipo de endereo: Exportao ';
               ELSE
                  IF :NEW.IDTPENDECLIE = 'T' THEN
                     V_IDTPENDECLIE := 'Identificador do tipo de endereo: Entrega ';
                  ELSE
                     IF :NEW.IDTPENDECLIE = 'O' THEN
                        V_IDTPENDECLIE := 'Identificador do tipo de endereo: Outros ';
                     ELSE
                        IF :NEW.IDTPENDECLIE = 'M' THEN
                           V_IDTPENDECLIE := 'Identificador do tipo de endereo: Comercial ';
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      END IF;

      V_DESC := 'Cdigo do cliente:  ' || :NEW.CDCLIENTE      ||' '||
                'Razao Social: '       || :NEW.NMRAZSOCPED    ||' '||
                'Inscricao: '          || :NEW.NRINSJURPED    ||' '||
                'I.E.: '               || :NEW.NRINSESTPED    ||' '||
                                          V_IDTPENDECLIE      ||' '||
                'Endereco: '           || :NEW.DSENDEPED      ||' '||
                'Seq.: '               || :NEW.NRSEQEND       ||' '||
                'Bairro: '             || :NEW.NMBAIRROPED    ||' '||
                'CEP: '                || :NEW.NRCEPPED       ||' '||
                'Fone: '               || :NEW.NRTELEPED      ||' '||
                'Cod.Pais:  '          || :NEW.CDPAISPED      ||' '||
                'Nm. Pais: '           || :NEW.NMPAISPED      ||' '||
                'Cod.Estado: '         || :NEW.SGESTADOPED    ||' '||
                'Nm. Estado: '         || :NEW.NMESTADOPED    ||' '||
                'Cod.Municipio: '      || :NEW.CDMUNICIPIOPED ||' '||
                'Nm.Municipio: '       || :NEW.NMMUNIPED      ||' '||'';

      V_IDTIPOOPER := '1';
      V_ITPESQ     := :NEW.CDFILIAL||:NEW.NRPEDIDO;
   ELSE
      IF UPDATING THEN
         V_DESC := 'Cd.Cliente: ' ||:NEW.CDCLIENTE ||' ' ;

         IF (NVL (:OLD.NMRAZSOCPED,'X') <> NVL(:NEW.NMRAZSOCPED, 'X')) THEN
            V_DESC := V_DESC || 'Razao Social: ' || :NEW.NMRAZSOCPED ||' ' ;
         END IF;

         IF (NVL (:OLD.NRINSJURPED,'X') <> NVL(:NEW.NRINSJURPED, 'X')) THEN
            V_DESC := V_DESC || 'Inscricao: ' || :NEW.NRINSJURPED ||' ' ;
         END IF;

         IF (NVL (:OLD.NRINSESTPED,'X') <> NVL(:NEW.NRINSESTPED, 'X')) THEN
            V_DESC := V_DESC || 'I.E.: ' || :NEW.NRINSESTPED ||' ' ;
         END IF;

         IF (NVL (:OLD.DSENDEPED,'X') <> NVL(:NEW.DSENDEPED, 'X')) THEN
            V_DESC := V_DESC || 'Endereco: ' || :NEW.DSENDEPED ||' ' ;
         END IF;

         IF (NVL (:OLD.NRSEQEND,'X') <> NVL(:NEW.NRSEQEND, 'X')) THEN
            V_DESC := V_DESC || 'Seq.: ' || :NEW.NRSEQEND ||' ' ;
         END IF;

         IF ( NVL(:OLD.NMBAIRROPED,'X') <> NVL(:NEW.NMBAIRROPED,'X')) THEN
            V_DESC := V_DESC || 'Bairro: ' || :NEW.NMBAIRROPED ||' ' ;
         END IF;

         IF (:OLD.IDTPENDECLIE    <> :NEW.IDTPENDECLIE   ) THEN
            V_DESC := V_DESC || 'Tipo de Endereo:  ' || :NEW.IDTPENDECLIE  ||'  ' ;
         END IF;

         IF ( NVL(:OLD.NRCEPPED,'X')  <> NVL(:NEW.NRCEPPED,'X')) THEN
            V_DESC := V_DESC || 'CEP: ' || :NEW.NRCEPPED  ||' ' ;
         END IF;

         IF ( NVL(:OLD.NRTELEPED,'X')  <> NVL(:NEW.NRTELEPED,'X')) THEN
            V_DESC := V_DESC || 'Fone: ' || :NEW.NRTELEPED  ||' ' ;
         END IF;

         IF (:OLD.CDPAISPED    <> :NEW.CDPAISPED   ) THEN
            V_DESC := V_DESC || 'Cod.Pais: ' || :NEW.CDPAISPED  ||' ' ;
         END IF;

         IF (:OLD.NMPAISPED    <> :NEW.NMPAISPED   ) THEN
            V_DESC := V_DESC || 'Nm.Pais: ' || :NEW.NMPAISPED  ||' ' ;
         END IF;

         IF (:OLD.SGESTADOPED    <> :NEW.SGESTADOPED   ) THEN
            V_DESC := V_DESC || 'Estado: ' || :NEW.SGESTADOPED  ||' ' ;
         END IF;

         IF (:OLD.NMESTADOPED    <> :NEW.NMESTADOPED   ) THEN
            V_DESC := V_DESC || 'Nm.Estado: ' || :NEW.NMESTADOPED  ||' ' ;
         END IF;

         IF (:OLD.CDMUNICIPIOPED <> :NEW.CDMUNICIPIOPED   ) THEN
            V_DESC := V_DESC || 'Cod.Municipio: ' || :NEW.CDMUNICIPIOPED  ||' ' ;
         END IF;

         IF (:OLD.NMMUNIPED <> :NEW.NMMUNIPED   ) THEN
            V_DESC := V_DESC || 'Nm.Municipio: ' || :NEW.NMMUNIPED  ||' ' ;
         END IF;

         V_IDTIPOOPER := '2';
         V_ITPESQ     := :NEW.CDFILIAL||:NEW.NRPEDIDO;

      ELSE
         IF DELETING THEN
            IF :NEW.IDTPENDECLIE = 'P' THEN
               V_IDTPENDECLIE :=  'Identificador do tipo de endereo: Principal ';
            ELSE
               IF :OLD.IDTPENDECLIE = 'C' THEN
                  V_IDTPENDECLIE := 'Identificador do tipo de endereo: Cobrana ';
               ELSE
                  IF :OLD.IDTPENDECLIE = 'E' THEN
                     V_IDTPENDECLIE := 'Identificador do tipo de endereo: Exterior ';
                  ELSE
                     IF :OLD.IDTPENDECLIE = 'X' THEN
                        V_IDTPENDECLIE := 'Identificador do tipo de endereo: Exportao ';
                     ELSE
                        IF :OLD.IDTPENDECLIE = 'T' THEN
                           V_IDTPENDECLIE := 'Identificador do tipo de endereo: Entrega ';
                        ELSE
                           IF :OLD.IDTPENDECLIE = 'O' THEN
                              V_IDTPENDECLIE := 'Identificador do tipo de endereo: Outros ';
                           ELSE
                              IF :OLD.IDTPENDECLIE = 'M' THEN
                                 V_IDTPENDECLIE := 'Identificador do tipo de endereo: Comercial ';
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;

            V_DESC := 'Cdigo do cliente:  ' || :OLD.CDCLIENTE      ||' '||
                      'Razao Social: '       || :OLD.NMRAZSOCPED    ||' '||
                      'Inscricao: '          || :OLD.NRINSJURPED    ||' '||
                      'I.E.: '               || :OLD.NRINSESTPED    ||' '||
                                                V_IDTPENDECLIE      ||' '||
                      'Endereco: '           || :OLD.DSENDEPED      ||' '||
                      'Seq.: '               || :OLD.NRSEQEND       ||' '||
                      'Bairro: '             || :OLD.NMBAIRROPED    ||' '||
                      'CEP: '                || :OLD.NRCEPPED       ||' '||
                      'Fone: '               || :OLD.NRTELEPED      ||' '||
                      'Cod.Pais:  '          || :OLD.CDPAISPED      ||' '||
                      'Nm. Pais: '           || :OLD.NMPAISPED      ||' '||
                      'Cod.Estado: '         || :OLD.SGESTADOPED    ||' '||
                      'Nm. Estado: '         || :OLD.NMESTADOPED    ||' '||
                      'Cod.Municipio: '      || :OLD.CDMUNICIPIOPED ||' '||
                      'Nm.Municipio: '       || :OLD.NMMUNIPED      ||' '||'';

            V_IDTIPOOPER := '3';
            V_ITPESQ     := :OLD.CDFILIAL||:OLD.NRPEDIDO;
         END IF;
      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_TAM := LENGTH(V_DESC);
      WHILE (V_TAM >= 0) LOOP

         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER)
                     VALUES   ('DADOSENDPED', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   SUBSTR(V_DESC,1,300), V_ITPESQ,
                                V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                                V_DSSERVMETHOD,   V_DSREMOTEOPER);
         V_DESC := SUBSTR(V_DESC, 300, V_TAM);
         V_TAM := LENGTH(V_DESC);
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PED_DADODENDPED','6.05.xxx'); END;
/

